<?php
/**
* Project:     Morgdkp2 eqdkp plus plug-in
* License:     Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported
* Link:    http://creativecommons.org/licenses/by-nc-sa/3.0/
* -----------------------------------------------------------------------
* Began:       2013
* -----------------------------------------------------------------------
* @author      Morgalm
* @copyright   2013-
* Based upon the EQdkp-Plus epgpimport plug-in and Morgalm's original morgdkp 2 plug-in for eqkdp plus 0.6
*/

define('EQDKP_INC', true);
define('IN_ADMIN', true);
$eqdkp_root_path = '../../../';
include_once($eqdkp_root_path.'common.php');

class morgdkp2_export extends page_generic {
	private $pdl;
	public $retrieve, $data, $timezones, $php_version, $percent_of_raids, $end_date, $num_raids, $webversion, $Cookies, $DKPcookies, $classids; 
			
	public static function __shortcuts() {
		$shortcuts = array('user', 'in', 'tpl', 'core', 'pm', 'config', 'html', 'db', 'game');
		return array_merge(parent::$shortcuts, $shortcuts);
	}  
	
	public function __construct() {
		$this->webversion = "3.3";
		$this->retrieve = array();
		$this->data = array();
		$this->classids = $this->game->get('classes');
		$this->timezones = array('Pacific'=>'America/Vancouver', 'Eastern'=>'America/New_York','Central'=>'America/Regina','Mountain'=>'America/Phoenix','AEST'=>'Australia/Melbourne', 'CET'=>'Europe/Berlin');
		$this->Cookies = array('TZonecook'=>$this->in->get('TZonecook'), 'rankidvaluecook'=>$this->in->get('rankidvaluecook'), 'attendanceidvaluecook'=>$this->in->get('attendanceidvaluecook'));
		$this->DKPcookies = array();
		for ($c = 1; $c <= 5; $c++) {
			$this->DKPcookies[$c] = $this->in->get('DKPcook'. $c);
		}
		$this->php_version = phpversion();
		$this->percent_of_raids = array(
					        '1'       => mktime(0, 0, 0, date('m'), date('d')-30, date('Y')),
					        '2'       => mktime(0, 0, 0, date('m'), date('d')-60, date('Y')), 
					        '3'       => mktime(0, 0, 0, date('m'), date('d')-90, date('Y'))
		);
		$this->percent_of_raids_index = array(
					        '1'       => '30',
					        '2'       => '60', 
					        '3'       => '90'
		);
		$this->end_date = time();
		$this->num_raids = 0;
		$this->user->check_auth('a_morgdkp2_export');
		include_once('../includes/morgdkp2_functions.class.php');
		$this->func = register('morgdkp2_functions');
			
		$handler = array(
			'doit'  => array('process' => 'output_dkp')
		);
		parent::__construct(false, $handler);
		$this->pdl = registry::register('plus_debug_logger'); 
		$this->process();
	}
	
	public function output_dkp(){
		if ($this->in->get('doit')) {
			require('../../../config.php');
			$timezone = $this->in->get('timezone');
			$rank = $this->in->get('rank');
			$interval = $this->GetTableIndex($this->percent_of_raids_index, $this->in->get('interval'));
			$end_date = time();
			$itempools = $this->func->GetDKPPools();	//all current pools
			$exportpools = array();				//pools chosen by user
			foreach ($itempools as $c => $val) {
				$dkpcook = $this->in->get('dkp'. $c);
				setcookie('DKPcook'. $c, $dkpcook, time()+3600*24*365);
				if ($this->user->$lang['morgexport_nopool'] != $dkpcook) $exportpools[$dkpcook] = true;
			}
			setcookie("TZonecook", $timezone, time()+3600*24*365);
			setcookie("rankidvaluecook", $rank, time()+3600*24*365);
			setcookie("attendanceidvaluecook", $this->in->get('interval'), time()+3600*24*365);
			if ($timezone and  $this->php_version > 5)  date_default_timezone_set($this->timezones[$timezone]);
			$data = '';
			$events = array();
			$eventlist = $this->func->FetchAllEvents();
			$aliaslist = $this->func->FetchAliasSimple();
			$classids = $this->classids;
			$rankids = $this->func->FetchAllRanks();
			$sql = "SELECT * FROM __multidkp2event";
			$result = $this->db->query($sql);
			while ($row = $this->db->fetch_record($result)) {
				$events[$itempools[$row['multidkp2event_multi_id']]][$row['multidkp2event_event_id']] = $eventlist[$row['multidkp2event_event_id']]['event_value'];
			}
			//$this->db->free_result($result);
			$dkpnum = 1;
			foreach ($itempools as $pluspoolnum => $poolname) {
				if ($exportpools[$poolname]) {
					$data .= "MorgDKP2_DKP$dkpnum = {\n\tTimestamp = " . strftime("%Y%m%d%H%M") . ",\n\tPool = \"$poolname\",\n\teqdkpsite = \"$dbname\",\n\tprefix = \"$table_prefix\",\n\tPoints = {\n\t\t"; 
					$num_raids = $this->GetTotalRaidCount($this->percent_of_raids[$interval], $end_date, $poolname, $events);
					$added = 0;
					$sql = "SELECT * FROM __members ORDER BY member_name";
					$result = $this->db->query($sql);
					while ($row = $this->db->fetch_record($result)) {
						if ($added) $data .= ",\n\t\t";
						$member = $row['member_id'];
						$membername = $row['member_name'];
						$sql = "SELECT __raids.event_id, SUM(raid_value) as 'earned' FROM __raid_attendees LEFT JOIN __raids ON __raid_attendees.raid_id=__raids.raid_id WHERE __raid_attendees.member_id = '" . 
							$member . "' GROUP by __raids.event_id";
						$earnedresult = $this->db->query($sql);
						$earned = 0;
						while ($earnedrow = $this->db->fetch_record($earnedresult)) {
							if ($events[$poolname][$earnedrow['event_id']]) $earned += $earnedrow['earned'];
						}
						$this->db->free_result($earnedresult);
						$sql = "SELECT __raids.event_id, SUM(__items.item_value) as 'spent' FROM __items LEFT JOIN __raids ON __items.raid_id=__raids.raid_id WHERE __items.member_id = '" . 
							$member . "' GROUP by __raids.event_id;";
						$spentresult = $this->db->query($sql);
						$spent = 0;
						while ($spentrow = $this->db->fetch_record($spentresult)) {
							if ($events[$poolname][$spentrow['event_id']]) $spent += $spentrow['spent'];
						}
						$this->db->free_result($earnedresult);
						$adjust = 0;
						$sql = "SELECT adjustment_reason, adjustment_value, event_id FROM __adjustments WHERE member_id = '" . $member . "';";
						$adjresult = $this->db->query($sql);
						while ($adjrow = $this->db->fetch_record($adjresult)) {
							if ($events[$poolname][$adjrow['event_id']]) $adjust += $adjrow['adjustment_value'];
						}
						$balance = $earned - $spent + $adjust;
						$added = 0;
						if (!isset($aliaslist) or !$aliaslist[$member]) {
							$class = $classids[$row['member_class_id']];
							$currentrankid = $rankids[$row['member_rank_id']];
							if ($rank == $this->user->lang('morgexport_noranks') or $rank == $this->user->lang('morgexport_allranks') or $rank == $currentrankid) {
								$attendance = $this->raid_count($this->percent_of_raids[$interval], $end_date, $member, $poolname, $events, $num_raids);
								$data .= "[\"$membername\"] = {earn = $earned,spent = $spent,adj = $adjust,bal = $balance,attend = $attendance,class = \"$class\"";
								if ($rank == $this->user->lang('morgexport_allranks')) {
									if ($currentrankid) {
										$data .= ",rank = \"$currentrankid\"";
									} else {
										$data .= ",rank = \"NONE\"";
									}
								}
								$data .= "}";
								$added = true;
							}
						}
					}
					$data .= "\n\t},\n\t";
					if (!empty($aliaslist)) {
						$data .= "Aliases = {\n\t\t";
						$c = 0;
						foreach ($aliaslist as $alias => $membername) {
							if ($c > 0) $data .= ",\n\t\t";
							$data .= "[\"$alias\"] = \"$membername\"";
							$c++;
						}
					} else $data .= "Aliases = {";
					if (!empty($eventlist)) {
						$data .= "\n\t},\n\tEvents = {\n\t\t";
						$c = 0;
						foreach ($eventlist as $eventid => $eventdata) {
							if ($events[$poolname][$eventid]) {
								if ($c > 0) $data .= ",\n\t\t";
								$eventname = $eventdata['event_name'];
								$data .= "[\"$eventname\"] = {id = {$eventid},value = {$eventdata['event_value']}}";
								$c++;
							}
						}
					} else $data .= "\n\t},\n\tEvents = {";
					if (!empty($rankids) and $rank == $this->user->lang('morgexport_allranks')) {
						$data .= "\n\t},\n\tRanks = {\n\t\t";
						$c = 1;
						foreach ($rankids as $id => $ranki) {
							if ($c > 1) $data .= ",\n\t\t";
							$data .= "[\"$c\"] = \"$ranki\"";
							$c++;
						}
					} 
					$data .= "\n\t},";
					$data .= "\n}\n";
				}
				$dkpnum++;
			}	
			
			$SaveLoc = "DKPInfo.lua";
			if (is_writable($SaveLoc)) {
				if (!$handle = fopen($SaveLoc, 'w')) {
		       		echo "Cannot open file ($SaveLoc)";
		       		exit;
		   		} else //echo "opened file $SaveLoc";
		   		if (mb_detect_encoding($data, "auto", true) != "UTF-8") { 
					if (fwrite($handle, utf8_encode($data)) === FALSE) {
		       			//echo "Cannot write to file ($SaveLoc)";
					exit;
					} //else echo "Wrote to file $SaveLoc";
				} else {
					if (fwrite($handle, $data) === FALSE) {
		       			//echo "Cannot write to file ($SaveLoc)";
					exit;
					} //else echo "Wrote to file $SaveLoc";
				}
				fclose($handle);
			} else echo "The file $SaveLoc is not writable";
			
			$options = array(
				'fieldtype' 	=> 'textarea',
				'name'		=> 'mydata',
				'javascript'	=> 'style="width:95%"',
				'rows'		=> 30,
				'value'		=> $data,
			);
			$this->tpl->assign_vars(array(
				'TITLE' => $this->user->lang('morgexport_title'). ' v'. $this->webversion,
				'DKP_TEXT' => $this->html->widget($options)
			));
		
			$this->core->set_vars(array(
				'page_title'        => $this->user->lang('morgexport_title'). ' v'. $this->webversion,
				'template_path'     => $this->pm->get_data('morgdkp2', 'template_path'),
				'template_file'     => 'admin/export_final.html',
				'display'           => true,
			));
		}
		      
	}
	
	public function display($messages=array(), $blnImportFinished=false) {
		$tzoneOptions = array();
		foreach($this->timezones as $key => $value){
			$tzoneOptions[$key] = $key;
		}
		$ranks = $this->func->FetchAllRanks();
		$ranks[] = $this->user->lang('morgexport_noranks');
		$ranks[] = $this->user->lang('morgexport_allranks');
		$rankdrop = array();
		foreach($ranks as $key => $value){
			$rankdrop[$value] = $value;
		}
		$intervaldrop = array();
		foreach($this->percent_of_raids_index as $key => $value){
			$intervaldrop[$value] = $value;
		}
		$this->tpl->assign_vars(array(
			'TITLE' 		=> $this->user->lang('morgexport_title'). ' v'. $this->webversion,
			'ENTER_FINAL_DATA' 	=> $this->user->lang('morgexport_process'),
			'TIMEZONES'		=> $this->html->dropdown('timezone', $tzoneOptions, $this->Cookies['TZonecook']),
			'RANKS'			=> $this->html->dropdown('rank', $rankdrop, $this->Cookies['rankidvaluecook']),
			'INTERVAL'		=> $this->html->dropdown('interval', $intervaldrop, $this->Cookies['attendanceidvaluecook']),
		));
		$itempools = $this->func->GetDKPPools();
		$itempools[] = $this->user->lang('morgexport_nopool');
		$itemdrop = array();
		foreach($itempools as $key => $value){
			$itemdrop[$value] = $value;
		}
		for ($c = 1, $size = count($itempools); $c < $size; $c++) {
			$this->tpl->assign_vars(array(
				'DKP'. $c			=> $this->html->dropdown('dkp'. $c, $itemdrop, $this->DKPcookies[$c]),
			));
			
		}		
		$this->core->set_vars(array(
			'page_title'        => $this->user->lang('morgexport_title'). ' v'. $this->webversion,
			'template_path'     => $this->pm->get_data('morgdkp2', 'template_path'),
			'template_file'     => 'admin/export.html',
			'display'           => true,
		));
	}
	
	private function GetTableIndex($table, $index) {
		foreach ($table as $i => $val) {
			if ($val == $index) return $i;
		}
		return 0;
	}
	
	private function GetTotalRaidCount($start_date, $end_date, $pool, $events) {
		$c = 0;
		$sql = "SELECT event_id FROM __raids WHERE (raid_date BETWEEN " . $start_date . " AND " . $end_date . ")";
		$result = $this->db->query($sql);
		while ($row = $this->db->fetch_record($result)) {
			if ($events[$pool][$row['event_id']]) $c++;
		}
		//$this->db->free_result($result);
		return $c;
	}

	private function raid_count($start_date, $end_date, $member_id, $pool, $events, $num_raids) {
		if ($num_raids > 0) {
			$sql = "SELECT event_id FROM __raids r, __raid_attendees ra WHERE (ra.raid_id = r.raid_id) AND (ra.member_id='" . $member_id . "') AND (r.raid_date BETWEEN " . $start_date . ' AND ' . $end_date . ')';
			$individual_raid_count_res = $this->db->query($sql);
			$c = 0;
			if ($individual_raid_count_res) {
				while ($raidrow = $this->db->fetch_record($individual_raid_count_res)) {
					if ($events[$pool][$raidrow['event_id']]) $c++;
				}
			} 
			$this->db->free_result($individual_raid_count_res);
			$percent_raids = round(($c / $num_raids) * 100);
			return $percent_raids;
		} else return 0;
	}

}
if(version_compare(PHP_VERSION, '5.3.0', '<')) registry::add_const('short_morgdkp2_export', morgdkp2_export::__shortcuts());
registry::register('morgdkp2_export');

?>