<?php
/**
* Project:     Morgdkp2 eqdkp plus plug-in
* License:     Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported
* Link:    http://creativecommons.org/licenses/by-nc-sa/3.0/
* -----------------------------------------------------------------------
* Began:       2013
* -----------------------------------------------------------------------
* @author      BlueWarlord
* @copyright   2013-
* Based upon the EQdkp-Plus epgpimport plug-in and Morgalm's original morgdkp 2 plug-in for eqkdp plus 0.6
*/


// EQdkp required files/vars
define('EQDKP_INC', true);
define('IN_ADMIN', true);
$eqdkp_root_path = './../../../';
include_once($eqdkp_root_path.'common.php');

class morgdkp2_import extends page_generic {
	private $pdl;
	private $DATAOUT;
	
	public static function __shortcuts() {
		$shortcuts = array('user', 'in', 'tpl', 'core', 'pdc', 'pm', 'config', 'html', 'db', 'logs');
		return array_merge(parent::$shortcuts, $shortcuts);
	}  
	
	public function __construct() {
		$this->DATAOUT = "";
		$this->webversion = "3.3";
		$this->RAID = array();
		$this->passalts = array();
		$this->dkpchange = array();
		$this->user->check_auth('a_morgdkp2_import');
		include_once('../includes/morgdkp2_parser.class.php');
		$this->parser = register('morgdkp2_parser');
		include_once('../includes/morgdkp2_functions.class.php');
		$this->func = register('morgdkp2_functions');	
		$handler = array(
			'insert'  => array('process' => 'insert_log'),
			'dochanges'  => array('process' => 'InserttoDB')
		);
		parent::__construct(false, $handler);
		$this->pdl = registry::register('plus_debug_logger'); 
		$this->process();
	}
	
	public function insert_log(){
		$log = $_POST['log'];
		if ( $log != ''){
			$parseresult = $this->parser->parse($log);
			if (!$parseresult) {
				//error
				$this->core->message($this->user->lang('morgdkp2_import_parse_error'), $this->user->lang('error'), 'red');
			} else {
				$this->core->message($this->user->lang('morgdkp2_import_parse_success'), $this->user->lang('success'), 'green');  
	
				// Set the DKP change information if available
				$dkpChangeHTML = $this->generateDKPChangeHTML();
				if (sizeof($dkpChangeHTML) > 0) {
					$this->tpl->assign_vars(array(
						'DKPChanged' => $dkpChangeHTML,
						'S_DKPChanged' => true,
					));
				} else {
					$this->tpl->assign_vars(array(
					'S_DKPChanged' => false,
					));
				}
		
				// Set the alias information if available
				$aliasHTML = $this->generateAliasHTML();
				if (sizeof($aliasHTML) > 0) {
					$this->tpl->assign_vars(array(
						'ALIAS' => $aliasHTML,
						'S_ALIAS' => true,
					));
				} else {
					$this->tpl->assign_vars(array(
					'S_ALIAS' => false,
					));
				}
			
				// Set the raid information if available
				if (isset($this->parser->RAID)) {
					$this->tpl->assign_vars(array(
						'RAIDS' => $this->generateRaidOverviewHTML(),
						'S_RAIDS' => true,
					));
				} else {
					$this->tpl->assign_vars(array(
					'S_RAIDS' => false,
					));
				}
			
				$this->tpl->assign_vars(array(
					'TITLE' => $this->user->lang('morgimport_import_preview'),
					'INPUT_INSTRUCTIONS' => $this->user->lang('morgimport_input_preview_instructions'),
					'ENTER_FINAL_DATA' => $this->user->lang('Enter_final_data')
				));
			
				$this->core->set_vars(array(
					'page_title'        => $this->user->lang('morgimport_import_preview'),
					'template_path'     => $this->pm->get_data('morgdkp2', 'template_path'),
					'template_file'     => 'admin/import_preview.html',
					'display'           => true,
					));
				}
		}      
	}
	
	public function display($messages=array(), $blnImportFinished=false) {
		//fetch itempools
		$itempools = $this->pdh->aget('itempool', 'name', 0, array($this->pdh->get('itempool', 'id_list')));
		asort($itempools);
	
		$this->tpl->assign_vars(array(
			'ITEMPOOLS'      => $this->html->DropDown('itempool', $itempools, false),
			'TITLE' => $this->user->lang('morgimport_import'). ' v3.3',
			'INPUT_INSTRUCTIONS' => $this->user->lang('morgimport_input_instructions'),
		));
	
		$this->core->set_vars(array(
			'page_title'        => $this->user->lang('morgimport_import'). ' v'. $this->webversion,
			'template_path'     => $this->pm->get_data('morgdkp2', 'template_path'),
			'template_file'     => 'admin/import.html',
			'display'           => true,
		));
	}
  
  	public function InserttoDB(){
	  	$this->DATAOUT = "";
		$this->RAID = $this->pdc->get('MDKP_RAID');
		$this->passalts = $this->pdc->get('MDKP_PASSALTS');
		$this->dkpchange = $this->pdc->get('MDKP_DKPCHANGE');
		if (isset($_POST['altfield'])) {
			$altarray = $_POST['altfield'];
			foreach ($altarray as $i => $alt) $altarray[$i]['alt'] = ucwords($altarray[$i]['alt']);
			$this->pdl->log("morgdkp2", 'altarray:'.$this->pdl->format_array($altarray));
			$newalts = $this->passalts;
			$newalts = $this->func->array_merge_keys($altarray, $newalts);
			$this->InsertAliases($newalts);
		}
		if (isset($_POST['raidfield'])) {
			$raidfields = $_POST['raidfield'];
			$raidfields = stripslashes_deep($raidfields);
			UpdateRaidData($raidfields);
		}
		if (isset($_POST['changevalue'])) {
			$needchanged = $this->dkpchange;
			$this->pdl->log("morgdkp2", 'Changes:'.$this->pdl->format_array($needchanged));
			$valuearray = $_POST['changevalue'];
			foreach ($valuearray as $i => $data) {
				$valuearray[$i]['members'] = ucwords($valuearray[$i]['members']);
				$valuearray[$i]['members'] = explode("\n", $valuearray[$i]['members']);
				foreach ($valuearray[$i]['members'] as $j => $name) $valuearray[$i]['members'][$j] = rtrim($valuearray[$i]['members'][$j]);
			}
			$this->pdl->log("morgdkp2", 'Post value:'.$this->pdl->format_array($valuearray));
			$this->AdjustDKP($needchanged, $valuearray);
		}
	  	
  		$this->tpl->assign_vars(array(
			'TITLE' => $this->user->lang('morgimport_import_result'). ' v'. $this->webversion,
			'DATAOUT' => $this->DATAOUT,
		));
	
		$this->core->set_vars(array(
			'page_title'        => $this->user->lang('morgimport_import_result'). ' v'. $this->webversion,
			'template_path'     => $this->pm->get_data('morgdkp2', 'template_path'),
			'template_file'     => 'admin/import_final.html',
			'display'           => true,
		));
		
		$this->pdc->del('MDKP_RAID');
		$this->pdc->del('MDKP_PASSALTS');
		$this->pdc->del('MDKP_DKPCHANGE');
		
  	
  	}
  	
	private function generateDKPChangeHTML() {
		$result = "";
		$Switches = $this->parser->Switches;
		if (isset($Switches['dkpchange'])) { 
			$result .="<u><b>DKP adjustments to be added to Database:</u></b><br><br>";
			$result .="<table border='1' cellpadding='12'>";
			$result .=" <tr><td><strong>Member </strong></td><td><strong>Adjustment </strong></td><td><strong>Database </strong></td><td><strong>Pool </strong></td><td><strong>Event/Note </strong></td></tr>";
			foreach ($this->parser->dkpchange as $i => $changes) {
				if ($changes['addtype'] == "Group" ) {
					$changevalue[$i]['members'] = implode("\n", $changes['members']);
					$result .= "<tr><td><textarea style='width: 150px; height: 100px;' name='changevalue[".$i."][members]'>".$changevalue[$i]['members']."</textarea>";
					$result .= "</td><td><input name='changevalue[".$i."][value]' size='3' value='".$changes['value']."'></td><td>";
					$result .= $changes['eqdkp']."</td><td>".$changes['pool']."</td><td>".$changes['event']."</td></tr>";
				} else {
					$result .= "<tr><td><input name='changevalue[".$i."][members]' size='20' value='".$changes['name']."'></td><td>";
					$result .= "<input name='changevalue[".$i."][value]' size='3' value='".$changes['value']."'></td><td>".$changes['eqdkp'];
					$result .= "</td><td>".$changes['pool']. "</td><td>".$changes['event']."</td></tr>";
				}
			} // End for-each
			$result .= "</table><hr>";
		}
		return $result;
	} // End of generateDKPChangeHTML()
  
	private function generateAliasHTML() {
		$result = "";
		$Switches = $this->parser->Switches;
		$newalts = $this->parser->passalts;
		$this->pdl->log("morgdkp2", 'Switches array:'.$this->pdl->format_array($newalts));
		
		if (isset($Switches['alias'])) {
			$result .= "<u><b>Alias changes to Database:</u></b><br><br>";
			$result .= "<table border='1' cellpadding='12'>";
			$result .= "<tr><td><strong>Alt </strong></td><td><strong>Main </strong></td><td><strong>Database </strong></td><td><strong>Pool </strong></td><td><strong>Action </strong></td></tr>";
			foreach ($newalts as $i => $aliases) {
				$result .= "<tr><td><input name='altfield[".$i."][alt]' value='".$aliases['alt']."'></td><td>".$aliases['main']."</td><td>";
				$result .= $aliases['eqdkp']."</td><td>".$aliases['pool']."</td><td>".$aliases['action']."</td></tr>";
			}
			$result .= "</table><hr>";
		} 
		return $result;
	} // End of generateAliasHTML()
  
	private function generateRaidOverviewHTML () {
		$result = "";
		$RAID = $this->parser->RAID;
		$this->pdl->log("morgdkp2", 'Transferred raid array:'.$this->pdl->format_array($RAID));
		
		foreach ($RAID as $i => $raiddata) {       
			$result .= "<b>Database: </b>&nbsp;&nbsp;".$raiddata['eqdkp'] . "<br><br>";
			$result .= "<b>Pool: </b>&nbsp;&nbsp;".$raiddata['pool']. "<br><br>";
			$result .= "<b>Zone</b>&nbsp;&nbsp;<input name='raidfield[". $i . "][zone]' value='". htmlentities($raiddata['zone'],ENT_QUOTES)."'>";
			$result .= "&nbsp;&nbsp;&nbsp;&nbsp;Use 0-sum DKP&nbsp;&nbsp;<input type='checkbox' name=raidfield[". $i ."][zsum]'><br><br>";
		
			foreach ($raiddata['events'] as $event => $eventdata) { 
				$result .= "<b>Event</b>&nbsp;&nbsp;<input name='raidfield[".$i."][events][".$event."][name]' size='40' value='".htmlentities($eventdata['name'], ENT_QUOTES)."'><br>";
				$result .= "<b>Note</b>&nbsp;&nbsp;&nbsp;&nbsp;<input name='raidfield[".$i."][events][". $event . "][note]' size='40' value='".htmlentities($eventdata['note'],ENT_QUOTES) ."'><br>";
				$result .= "<b>Value</b>&nbsp;&nbsp;<input name='raidfield[".$i. "][events][".$event. "][value]' size='3' value='". $eventdata['value'] . "'><br>";
				$result .= "<b>Time</b>&nbsp;&nbsp;&nbsp;". strftime("%Y/%m/%d %H:%M:%S", $eventdata['time']). "<br><br>";
				$raidfield[$i]['events'][$event]['attendees'] = implode("\n", $eventdata['attendees']);
			
				$result .= "<b>Attendees</b><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
				$result .= "<textarea style='width: 150px; height: 300px;' name=raidfield[".$i."][events][".$event. "][attendees]'>".$raidfield[$i]['events'][$event]['attendees']."</textarea><br>";
		
				if (isset($raiddata['loot'][$eventdata['index']]) && $raiddata['loot'][$eventdata['index']]) {
					foreach ($raiddata['loot'][$eventdata['index']] as $loot => $lootdata) { 
						$eventname = $eventdata['index'];
						$result .= "<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
						$result .= "<input name='raidfield[".$i."][loot][".$eventname."][".$loot."][ItemName]' size='30' value='".htmlentities($lootdata['ItemName'],ENT_QUOTES)."'><br>";
						$result .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
						$result .= "<input name='raidfield[".$i."][loot][".$eventname."][".$loot."][Costs]' size='30' value='".$lootdata['Costs']."'><br>";
						$result .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
						$result .= "<input name='raidfield[".$i."][loot][".$eventname."][".$loot."][Player]' size='30' value='".$lootdata['Player']."'><br>";
					}
				} 
				if (isset($raiddata['loot']['Trash mob']) && $raiddata['loot']['Trash mob'] and $eventdata['trash'] == 2) {
					$result .= "<br>";
					foreach ($raiddata['loot']['Trash mob'] as $tloot => $trashdata) {
						$result .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
						$result .= "<input name='raidfield[".$i."][loot][Trash mob][".$tloot."][ItemName]' size='30' value='".htmlentities($trashdata['ItemName'],ENT_QUOTES)."'><br>";
						$result .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
						$result .= "<input name='raidfield[".$i."][loot][Trash mob][".$tloot."][Costs]' size='30' value='".$trashdata['Costs']. "'><br>";
						$result .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
						$result .= "<input name='raidfield[".$i."][loot][Trash mob][".$tloot."][Player]' size='30' value='".$trashdata['Player']."'><br><br>";
					}
				}
				$result .= "<br><hr>";
			}
		$result .= "<hr>";
		}    
		return $result;
	}
	
	private function InsertAliases($alts) {
		foreach ($alts as $tab) {
			if ($tab['alt']) {
				$currentaliases = $this->func->FetchAliases($tab['main']);
				$exists = false;
				foreach ($currentaliases as $aliasdata) {
					if ($aliasdata['alias_name'] == $tab['alt']) $exists = true;
				}
				if ($tab['action'] == "ADD") {
					if (!$exists) {
						$result = $this->db->query("INSERT INTO __ctrt_aliases :params", array('alias_member_id' => $tab['id'], 'alias_name' => stripslashes($tab['alt'])));	
	      					if ($result) {
	      						$this->DATAOUT .= "Added alias: " . stripslashes($tab['alt']) . " of " . stripslashes($tab['main']) . " to database: " . $tab['eqdkp'] . "\n";                                     
							$log_action = array('header' => '{L_ACTION_CTRT_ALIAS_ADDED}',
											'{L_CTRT_LABEL_ALIAS_NAME}' => $tab['alt'],
											'{L_CTRT_LABEL_MEMBER_NAME}' => $tab['main'],
											'{L_ADDED_BY}' => $this->user->data['username']);
							$this->logs->add($log_action['header'], $log_action, true, 'morgdkp2');
						} 
					} else 	$this->DATAOUT .= "Can't add alias: " . stripslashes($tab['alt']) . " of " . stripslashes($tab['main']) . " to database: " . $tab['eqdkp'] . ".  Alias already exists.\n"; 
				} 
				if ($tab['action'] == "DELETE") {
					if ($exists) {
						$sql = "DELETE FROM __ctrt_aliases WHERE alias_name = '"  . stripslashes($tab['alt'] . "'");
						$result = $this->db->query($sql);
	      					if ($result) {
	      						$this->DATAOUT .= "Deleted alias: " . stripslashes($tab['alt']) . " of " . stripslashes($tab['main']) . " from database: " . $tab['eqdkp'] . "\n";                                     
							$log_action = array('header' => '{L_ACTION_CTRT_ALIAS_DELETED}',
											'{L_CTRT_LABEL_ALIAS_NAME}' => $tab['alt'],
											'{L_CTRT_LABEL_MEMBER_NAME}' => $tab['main'],
											'{L_ADDED_BY}' => $this->user->data['username']);
							$this->logs->add($log_action['header'], $log_action, true, 'morgdkp2');
						} 
					} else $this->DATAOUT .= "Can't delete alias: " . stripslashes($tab['alt']) . " of " . stripslashes($tab['main']) . " from database: " . $tab['eqdkp'] . ".  Alias does not exist.\n";   
				}
			} 
		}
		$this->DATAOUT .= "\n";                                     
	}

	private function AdjustDKP($changes, $parsedata) {
		$user = $this->user->data['username'];
		foreach ($changes as $changeid => $change) {
			$change['members'] = $this->func->Arraydiff($parsedata[$changeid]['members'], $change['members']);
			$this->pdl->log("morgdkp2", 'Merged members:'.$this->pdl->format_array($change));
			$change['value'] = $parsedata[$changeid]['value'];
			$change['members'] = $this->func->CheckAlias($change['members']);
			$change['members'] = array_unique($change['members']);
			$change['event_id'] = $this->func->FetchEvent($change['event'], $change['value'], $change['pool']);
			if ($change['value']) {
				$grp_key = $this->func->gen_group_key(time(), stripslashes($change['event']), $change['value']);
				if ($change['name'] == "Group") {
					$counter = 0;
					foreach ($change['members'] as $name) {
						$adjusted = $this->func->AddMultiAdjustment($name, $change, $grp_key);
						$counter++;
					}
					$log_action = array('header' => '{L_ACTION_INDIVADJ_ADDED}',
									'{L_ADJUSTMENT}' => $change['value'],
									'{L_REASON}' => addslashes($change['event']),
									'{L_MEMBERS}' =>  implode(", ", $change['members']),
									'{L_EVENT}' => addslashes($change['event']),
									'{L_ADDED_BY}' =>addslashes($user));
					$this->DATAOUT .= "Added group adjustment to $counter members by " . $change['value'] . " DKP in database: " . $change['eqdkp'] . "\n";                                     
				} else {
					$adjusted = $this->func->AddMultiAdjustment($change['members'][1], $change, $grp_key);
					$log_action = array('header' => '{L_ACTION_INDIVADJ_ADDED}',
									'{L_ADJUSTMENT}' => $change['value'],
									'{L_REASON}' => addslashes($change['event']),
									'{L_MEMBERS}' =>  $change['name'],
									'{L_EVENT}' => addslashes($change['event']),
									'{L_ADDED_BY}' =>addslashes($user));
					$this->DATAOUT .= "Added member adjustment: " . $change['name'] . " by " . $change['value'] . " DKP in database: " . $change['eqdkp'] . "\n";                           
				}
				if ($adjusted) $this->logs->add($log_action['header'], $log_action, true, 'morgdkp2');
			}
		}
		$this->DATAOUT .= "\n";           
	}
	
}
if(version_compare(PHP_VERSION, '5.3.0', '<')) registry::add_const('short_morgdkp2_import', morgdkp2_import::__shortcuts());
registry::register('morgdkp2_import');

?>

